//
//  DetailsTabViewController.m
//  IAmBeerApp
//
//  Created by Class Account on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "DetailsTabViewController.h"


@implementation DetailsTabViewController
@synthesize beerBrewery, beerABV, beerIBU, beerSmell, beerSeason, beerColor, beerAroma, seasonsPicker, toolbar;
@synthesize listOfSeasons;

#define DEFAULT_CURRENT_ROW 2
/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	listOfSeasons = [[NSArray alloc] initWithObjects:@"Nonseasonal",@"Spring",@"Summer",@"Autumn",@"Winter",nil];
	[seasonsPicker selectRow:(NSInteger)DEFAULT_CURRENT_ROW inComponent:0 animated:YES];
	currentSeason = DEFAULT_CURRENT_ROW;
	
	toolbar.hidden = YES;
	seasonsPicker.hidden = YES;
	
}

//Methods for UIPicker
- (NSInteger) numberOfComponentsInPickerView:(UIPickerView *)pickerView {
	return 1;
}

- (NSInteger)pickerView:(UIPickerView *)thePickerView
numberOfRowsInComponent:(NSInteger)component {
	
	return [listOfSeasons count];
}

- (NSString *)pickerView:(UIPickerView *)thePickerView
			 titleForRow:(NSInteger)row forComponent:(NSInteger)component {
	
	return [listOfSeasons objectAtIndex:row];
}

- (void)pickerView:(UIPickerView *)thePickerView
	  didSelectRow:(NSInteger)row inComponent:(NSInteger)component {
	
	currentSeason = (int)row;

}
/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (IBAction)changeSeason:(id)sender {
	toolbar.hidden = NO;
	seasonsPicker.hidden = NO;

}

- (IBAction)selectSeason:(id)sender {
	NSString *season = [listOfSeasons objectAtIndex:(NSInteger)currentSeason];
	[beerSeason setTitle:season forState:UIControlStateNormal];
	
	toolbar.hidden = YES;
	seasonsPicker.hidden = YES;
}

- (IBAction)cancelSelectSeason:(id)sender {
	toolbar.hidden = YES;
	seasonsPicker.hidden = YES;
}

- (BOOL)textFieldShouldBeginEditing: (UITextField *)theTextField {
	if (theTextField == beerABV || theTextField == beerIBU)
		[theTextField setKeyboardType:UIKeyboardTypeNumbersAndPunctuation];
	
	return YES;
}

- (BOOL)textFieldShouldReturn: (UITextField *)theTextField {
	if (theTextField == beerABV && [beerABV.text hasSuffix:@"%"] == NO) {
		beerABV.text = [beerABV.text stringByAppendingString:@"%"];
	}
	
	[theTextField resignFirstResponder];
	
	return YES;
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[beerBrewery release];
	[beerABV release];
	[beerIBU release];
	[beerSmell release];
	[beerSeason release];
	[beerColor release];
	[beerAroma release];
	
	[listOfSeasons release];
	[seasonsPicker release];
	[toolbar release];
    [super dealloc];
}


@end
