//
//  MainView.m
//  Taste Wheel
//
//  Created by Calvin Lin on 4/2/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "MainView.h"
#import "IAmBeerAppAppDelegate.h"
#include "math.h"

@implementation MainView

/* NOTES
 Center of wheel: (160,217)
 
 MALTY slice - Slice 1
 Left corner: (16, 217)
 Right corner: (60, 116)
 
 NUTTY slice - Slice 2
 Left corner: (60, 116)
 Right corner: (160, 73)
 
 HOPPY slice - Slice 3
 Left corner: (160, 73)
 Right corner: (262, 116)
 
 CREAMY slice - Slice 4
 Left corner: (262, 116)
 Right corner: (304, 217)
 
 FLORAL slice - Slice 5
 Left corner: (262, 320)
 Right corner: (304, 217)
 
 SWEET slice - Slice 6
 Left corner: (160, 360)
 Right corner: (262, 320)
 
 FRUITY slice - Slice 7
 Left corner: (60, 320)
 Right corner: (160, 360)
 
 FULL BODY slice - Slice 8
 Left corner: (16, 217)
 Right corner: (60, 320)
 
 */
 
float edge1X = 1; float edge1Y = 169;
float edge2X = 48; float edge2Y = 56;
float edge3X = 160; float edge3Y = 9;
float edge4X = 273; float edge4Y = 56;
float edge5X = 319; float edge5Y = 169;
float edge6X = 273; float edge6Y = 282;
float edge7X = 160; float edge7Y = 327;
float edge8X = 48; float edge8Y = 282;

float radius = 160;

float centerX = 160;
float centerY = 169;
BOOL inSlice = NO;
int sliceNumber = -1;

float distArg = 0;
float xArg = 0;
float yArg = 0;


float s1val = 0; float s2val = 0; float s3val = 0; float s4val = 0;
float s5val = 0; float s6val = 0; float s7val = 0; float s8val = 0;

CGPoint slice1L, slice1R, slice2L, slice2R, slice3L, slice3R, slice4L, slice4R, slice5L, slice5R;
CGPoint slice6L, slice6R, slice7L, slice7R, slice8L, slice8R;

@synthesize w;
@synthesize s1adj, s2adj, s3adj, s4adj, s5adj, s6adj, s7adj, s8adj;

- (void)loadSavedData {
	NSString *error;
	NSString *plistPath;
	NSPropertyListFormat format;
	NSString *rootPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
	plistPath = [rootPath stringByAppendingPathComponent:@"TasteWheel2.plist"];
	if (![[NSFileManager defaultManager] fileExistsAtPath:plistPath]) {
		plistPath = [[NSBundle mainBundle] pathForResource:@"TasteWheel2" ofType:@"plist"];
	}
	NSData *plistXML = [[NSFileManager defaultManager] contentsAtPath:plistPath];
	NSDictionary *temp = (NSDictionary *)[NSPropertyListSerialization 
										  propertyListFromData:plistXML mutabilityOption:NSPropertyListMutableContainersAndLeaves 
										  format:&format errorDescription:&error];
	
	NSString *numTimes = [temp objectForKey:@"FirstTime"];
	if (numTimes == nil) {
		// Show pop-up
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Taste Wheel Instructions" 
														message:@"To rate the beer on each aspect of the wheel, TOUCH and DRAG within a slice. The wheel allows you to describe how much a beer fits each characteristic.\n\nCheck out the Results tab once you're done!"
													   delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];
	}
	
}

- (void)writeData {
	NSString *error;
	NSString *rootPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
	NSString *plistPath = [rootPath stringByAppendingPathComponent:@"TasteWheel2.plist"];
	//[myPList setObject:anObject forKey:@"aKey"];
	NSDictionary *plistDict = [NSDictionary dictionaryWithObjects:[NSArray arrayWithObjects:@"0",nil]
														  forKeys:[NSArray arrayWithObjects:@"FirstTime",nil]];
	NSData *plistData = [NSPropertyListSerialization dataFromPropertyList:plistDict format:NSPropertyListXMLFormat_v1_0 errorDescription:&error];
	if(plistData) {
		[plistData writeToFile:plistPath atomically:YES];
	}	
}

- (void)awakeFromNib {
	w.image = [UIImage imageNamed:@"tastewheel-proto3.png"];
	slice1L = CGPointMake(centerX,centerY); slice1R = CGPointMake(centerX,centerY);
	slice2L = CGPointMake(centerX,centerY); slice2R = CGPointMake(centerX,centerY);
	slice3L = CGPointMake(centerX,centerY); slice3R = CGPointMake(centerX,centerY);
	slice4L = CGPointMake(centerX,centerY); slice4R = CGPointMake(centerX,centerY);
	slice5L = CGPointMake(centerX,centerY); slice5R = CGPointMake(centerX,centerY);
	slice6L = CGPointMake(centerX,centerY); slice6R = CGPointMake(centerX,centerY);
	slice7L = CGPointMake(centerX,centerY); slice7R = CGPointMake(centerX,centerY);
	slice8L = CGPointMake(centerX,centerY); slice8R = CGPointMake(centerX,centerY); 
	
	s1adj.hidden = s2adj.hidden = s3adj.hidden = s4adj.hidden = YES;
	s5adj.hidden = s6adj.hidden = s7adj.hidden = s8adj.hidden = YES;
	s1adj.text = s2adj.text = s3adj.text = s4adj.text = @"Not";
	s5adj.text = s6adj.text = s7adj.text = s8adj.text = @"Not";

	[self loadSavedData];
	[self writeData];
}

- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        // Initialization code
    }
    return self;
}

- (IBAction)showInstructions {
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Taste Wheel Instructions" 
													message:@"To rate the beer on each aspect of the wheel, TOUCH and DRAG within a slice. The wheel allows you to describe how much a beer fits each characteristic.\n\nCheck out the Results tab once you're done!"
												   delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
	[alert show];
	[alert release];
}

- (void)setTriangle:(int)sliceNum dist:(float)distance {
	if (distance > radius)
		distance = radius;
	if (distance < 0)
		distance = 0;
	distArg = distance;
	float percent = distance/radius;
	
	NSString *temp;
	if (percent == 0)
		temp = [NSString stringWithFormat:@"not"];
	else if (percent <= 0.2) 
		temp = [NSString stringWithFormat:@"hardly"];
	else if (percent <= 0.4) 
		temp = [NSString stringWithFormat:@"slightly"];
	else if (percent <= 0.6)
		temp = [NSString stringWithFormat:@"fairly"];
	else if (percent <= 0.8)
		temp = [NSString stringWithFormat:@"pretty"];
	else
		temp = [NSString stringWithFormat:@"very"];
	
	float p1x, p1y, p2x, p2y;
	if (sliceNum == 1) {
		s1val = percent;
		// Edge 1
		p1x = (edge1X - centerX) * percent;
		p1y = 0;
		// Edge 2
		p2x = (edge2X - centerX) * percent;
		p2y = (edge2Y - centerY) * percent;
		
		p1y -= 9;
		p2y -= 9;
		
		s1adj.hidden = NO;
		s1adj.text = temp;
	}
	else if (sliceNum == 2) {
		s2val = percent;
		// Edge 2
		p1x = (edge2X - centerX) * percent;
		p1y = (edge2Y - centerY) * percent;
		// Edge 3
		p2x = (edge3X - centerX) * percent;
		p2y = (edge3Y - centerY) * percent;
		
		p1y -= 9;
		p2y -= 9;
		
		s2adj.hidden = NO;
		s2adj.text = temp;
	}
	else if (sliceNum == 3) {
		s3val = percent;
		// Edge 3
		p1x = (edge3X - centerX) * percent;
		p1y = (edge3Y - centerY) * percent;
		// Edge 4
		p2x = (edge4X - centerX) * percent;
		p2y = (edge4Y - centerY) * percent;
		
		p1y -= 9;
		p2y -= 9;
		
		s3adj.hidden = NO;
		s3adj.text = temp;
	}
	else if (sliceNum == 4) {
		s4val = percent;
		// Edge 4
		p1x = (edge4X - centerX) * percent;
		p1y = (edge4Y - centerY) * percent;
		// Edge 5
		p2x = (edge5X - centerX) * percent;
		p2y = (edge5Y - centerY) * percent;
		
		p1y -= 9;
		p2y -= 9;
		
		s4adj.hidden = NO;
		s4adj.text = temp;
	}
	else if (sliceNum == 5) {
		s5val = percent;
		// Edge 5
		p1x = (edge5X - centerX) * percent;
		p1y = (edge5Y - centerY) * percent;
		// Edge 6
		p2x = (edge6X - centerX) * percent;
		p2y = (edge6Y - centerY) * percent;
		
		p1y -= 9;
		p2y -= 9;
		
		s5adj.hidden = NO;
		s5adj.text = temp;
	}
	else if (sliceNum == 6) {
		s6val = percent;
		// Edge 6
		p1x = (edge6X - centerX) * percent;
		p1y = (edge6Y - centerY) * percent;
		// Edge 7
		p2x = (edge7X - centerX) * percent;
		p2y = (edge7Y - centerY) * percent;
		
		p1y -= 9;
		p2y -= 9;
		
		s6adj.hidden = NO;
		s6adj.text = temp;
	}
	else if (sliceNum == 7) {
		s7val = percent;
		// Edge 7
		p1x = (edge7X - centerX) * percent;
		p1y = (edge7Y - centerY) * percent;
		// Edge 8
		p2x = (edge8X - centerX) * percent;
		p2y = (edge8Y - centerY) * percent;
		
		p1y -= 9;
		p2y -= 9;
		
		s7adj.hidden = NO;
		s7adj.text = temp;
	}
	else if (sliceNum == 8) {
		s8val = percent;
		// Edge 8
		p1x = (edge8X - centerX) * percent;
		p1y = (edge8Y - centerY) * percent;
		// Edge 1
		p2x = (edge1X - centerX) * percent;
		p2y = (edge1Y - centerY) * percent;
		
		p1y -= 9;
		p2y -= 9;
		
		s8adj.hidden = NO;
		s8adj.text = temp;
	}
	
	p1x += centerX;
	p1y += centerY;
	p2x += centerX;
	p2y += centerY;
	
	CGPoint pt1 = CGPointMake(p1x, p1y);
	CGPoint pt2 = CGPointMake(p2x, p2y);
	
	if (sliceNum == 1) { slice1L = pt1; slice1R = pt2; }
	else if (sliceNum == 2) { slice2L = pt1; slice2R = pt2; }
	else if (sliceNum == 3) { slice3L = pt1; slice3R = pt2; }
	else if (sliceNum == 4) { slice4L = pt1; slice4R = pt2; }
	else if (sliceNum == 5) { slice5L = pt1; slice5R = pt2; }
	else if (sliceNum == 6) { slice6L = pt1; slice6R = pt2; }
	else if (sliceNum == 7) { slice7L = pt1; slice7R = pt2; }
	else if (sliceNum == 8) { slice8L = pt1; slice8R = pt2; }
}

- (void)drawRect:(CGRect)rect {
    // Drawing code
}

- (void)drawStuff {
	UIGraphicsBeginImageContext(w.frame.size);
	w.image = [UIImage imageNamed:@"tastewheel-proto3.png"];
	[w.image drawInRect:CGRectMake(0,0,w.frame.size.width, w.frame.size.height)];
	
	CGContextRef contextRef = UIGraphicsGetCurrentContext();
	
	if (!(slice1L.x==centerX && slice1R.x==centerX)) {
		CGContextSetRGBFillColor(contextRef, 0/255, 0/255, 255/255, 0.75); 
		CGContextBeginPath(contextRef);
		CGContextMoveToPoint(contextRef, centerX, centerY-9);
		CGContextAddLineToPoint(contextRef, slice1L.x, slice1L.y);
		CGContextAddLineToPoint(contextRef, slice1R.x, slice1R.y);
		CGContextClosePath(contextRef);
		[[UIColor colorWithRed:0/255 green:0/255 blue:255/255 alpha:0.75] setStroke];
		[[UIColor colorWithRed:0/255 green:0/255 blue:255/255 alpha:0.75] setFill];
		CGContextDrawPath(contextRef, kCGPathFillStroke);
	}
	
	if (!(slice2L.x==centerX && slice2R.x==centerX)) {
		CGContextSetRGBFillColor(contextRef, 0/255, 255/255, 0/255, 0.75); 
		CGContextBeginPath(contextRef);
		CGContextMoveToPoint(contextRef, centerX, centerY-9);
		CGContextAddLineToPoint(contextRef, slice2L.x, slice2L.y);
		CGContextAddLineToPoint(contextRef, slice2R.x, slice2R.y);
		CGContextClosePath(contextRef);
		[[UIColor colorWithRed:0/255 green:255/255 blue: 0/255 alpha:0.75] setStroke];
		[[UIColor colorWithRed:0/255 green:255/255 blue:0/255 alpha:0.75] setFill];
		CGContextDrawPath(contextRef, kCGPathFillStroke);
	}
	
	if (!(slice3L.x==centerX && slice3R.x==centerX)) {
		CGContextSetRGBFillColor(contextRef, 255/255, 0/255, 0/255, 0.75); 
		CGContextBeginPath(contextRef);
		CGContextMoveToPoint(contextRef, centerX, centerY-9);
		CGContextAddLineToPoint(contextRef, slice3L.x, slice3L.y);
		CGContextAddLineToPoint(contextRef, slice3R.x, slice3R.y);
		CGContextClosePath(contextRef);
		[[UIColor colorWithRed:255/255 green:0/255 blue:0/255 alpha:0.75] setStroke];
		[[UIColor colorWithRed:255/255 green:0/255 blue:0/255 alpha:0.75] setFill];
		CGContextDrawPath(contextRef, kCGPathFillStroke);
	}
	
	if (!(slice4L.x==centerX && slice4R.x==centerX)) { 
		CGContextSetRGBFillColor(contextRef, 0/255, 255/255, 255/255, 0.75); 
		CGContextBeginPath(contextRef);
		CGContextMoveToPoint(contextRef, centerX, centerY-9);
		CGContextAddLineToPoint(contextRef, slice4L.x, slice4L.y);
		CGContextAddLineToPoint(contextRef, slice4R.x, slice4R.y);
		CGContextClosePath(contextRef);
		[[UIColor colorWithRed:0/255 green:255/255 blue:255/255 alpha:0.75] setStroke];
		[[UIColor colorWithRed:0/255 green:255/255 blue:255/255 alpha:0.75] setFill];
		CGContextDrawPath(contextRef, kCGPathFillStroke);
	}
	
	if (!(slice5L.x==centerX && slice5R.x==centerX)) { 
		CGContextSetRGBFillColor(contextRef, 255/255, 255/255, 0/255, 0.75); 
		CGContextBeginPath(contextRef);
		CGContextMoveToPoint(contextRef, centerX, centerY-9);
		CGContextAddLineToPoint(contextRef, slice5L.x, slice5L.y);
		CGContextAddLineToPoint(contextRef, slice5R.x, slice5R.y);
		CGContextClosePath(contextRef);
		[[UIColor colorWithRed:255/255 green:255/255 blue:0/255 alpha:0.75] setStroke];
		[[UIColor colorWithRed:255/255 green:255/255 blue:0/255 alpha:0.75] setFill];
		CGContextDrawPath(contextRef, kCGPathFillStroke);
	}
	
	if (!(slice6L.x==centerX && slice6R.x==centerX)) { 
		CGContextSetRGBFillColor(contextRef, 0/255, 255/255, 0/255, 0.75); 
		CGContextBeginPath(contextRef);
		CGContextMoveToPoint(contextRef, centerX, centerY-9);
		CGContextAddLineToPoint(contextRef, slice6L.x, slice6L.y);
		CGContextAddLineToPoint(contextRef, slice6R.x, slice6R.y);
		CGContextClosePath(contextRef);
		[[UIColor colorWithRed:0/255 green:255/255 blue:0/255 alpha:0.75] setStroke];
		[[UIColor colorWithRed:0/255 green:255/255 blue:0/255 alpha:0.75] setFill];
		CGContextDrawPath(contextRef, kCGPathFillStroke);
	}
	
	if (!(slice7L.x==centerX && slice7R.x==centerX)) { 
		CGContextSetRGBFillColor(contextRef, 255/255, 0/255, 255/255, 0.75); 
		CGContextBeginPath(contextRef);
		CGContextMoveToPoint(contextRef, centerX, centerY-9);
		CGContextAddLineToPoint(contextRef, slice7L.x, slice7L.y);
		CGContextAddLineToPoint(contextRef, slice7R.x, slice7R.y);
		CGContextClosePath(contextRef);
		[[UIColor colorWithRed:255/255 green:0/255 blue:255/255 alpha:0.75] setStroke];
		[[UIColor colorWithRed:255/255 green:0/255 blue:255/255 alpha:0.75] setFill];
		CGContextDrawPath(contextRef, kCGPathFillStroke);
	}
	
	if (!(slice8L.x==centerX && slice8R.x==centerX)) { 
		CGContextSetRGBFillColor(contextRef, 10/255, 10/255, 10/255, 0.75); 
		CGContextBeginPath(contextRef);
		CGContextMoveToPoint(contextRef, centerX, centerY-9);
		CGContextAddLineToPoint(contextRef, slice8L.x, slice8L.y);
		CGContextAddLineToPoint(contextRef, slice8R.x, slice8R.y);
		CGContextClosePath(contextRef);
		[[UIColor colorWithRed:10/255 green:10/255 blue:10/255 alpha:0.75] setStroke];
		[[UIColor colorWithRed:10/255 green:10/255 blue:10/255 alpha:0.75] setFill];
		CGContextDrawPath(contextRef, kCGPathFillStroke);
	}
	
	w.image = UIGraphicsGetImageFromCurrentImageContext();
	UIGraphicsEndImageContext();
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	for (UITouch *touch in touches) {
		CGPoint point = [touch locationInView:self];
		//NSLog(@"x:%f\t\ty:%f\n", point.x, point.y);
		
		// Check if point is within circle
		float distance = sqrt(pow(point.x-centerX,2) + pow(point.y-centerY,2));
		//NSLog (@"distance: %f\n", distance);
		
		float angle;
		
		// Inside circle: distance from center is within radius
		if (distance <= radius+5 && distance != 0) {
			inSlice = YES;
			
			// Check which slice the point is in based on angle
			double v1x = -1;
			double v1y = 0;
			double v2x = point.x - centerX;
			double v2y = point.y - centerY;
			double v1mag = sqrt(pow(v1x,2) + pow(v1y,2));
			double v2mag = sqrt(pow(v2x, 2) + pow(v2y,2));
			v1x /= v1mag; v1y /= v1mag;
			v2x /= v2mag; v2y /= v2mag;
			
			double dotProd = (v1x * v2x) + (v1y * v2y);
			angle = acos(dotProd) * (180/3.14159265); // in degrees
		//	NSLog(@"angle: %f\n", angle);
			
			if (point.y <= centerY) {
				if (angle >= 0.0 && angle < 45) {
					sliceNumber = 1;
				}
				else if (angle >= 45 && angle < 90) {
					sliceNumber = 2;
				}
				else if (angle >= 90 && angle < 135) {
					sliceNumber = 3;
				}	
				else if (angle >= 135 && angle <= 180) {
					sliceNumber = 4;
				}
			}
			else {
				if (angle < 180 && angle >= 135) {
					sliceNumber = 5;
				}
				else if (angle < 135 && angle >= 90) {
					sliceNumber = 6;
				}
				else if (angle < 90 && angle >= 45) {
					sliceNumber= 7;
				}
				else if (angle < 45 && angle >= 0) {
					sliceNumber = 8;
				}
			}
			xArg = point.x;
			yArg = point.y;
			[self setTriangle:sliceNumber dist:distance];			
		}
		// Touch started at center of the wheel
		else if (distance == 0) {
			inSlice = YES;
			xArg = point.x;
			yArg = point.y;
			sliceNumber = 1;
			[self setTriangle:1 dist:0.00001];			
		}
		// Point is not in the circle
		else 
			inSlice = NO;
		
	}
	
	//[self setNeedsDisplay];

	[self drawStuff];
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
	if (inSlice == YES && sliceNumber != -1) {
		for (UITouch *touch in touches) {
			CGPoint point = [touch locationInView:self];
			
			// Get distance between initial touch and where touch moved
			float distance = sqrt(pow(point.x-xArg,2) + pow(point.y-yArg,2));			
			float d;
			
			// Check if move was increase or decrease (depends on which slice)
			// Slices 1 & 2 -> up/left vs down/right
			if (sliceNumber == 1 || sliceNumber == 2) {
				if (point.x > xArg)  // moved right
					d = distArg - distance;
				else if (point.x < xArg)  // moved left
					d = distArg + distance;
				else if (point.y < yArg)  // moved up
					d = distArg + distance;
				else if (point.y > yArg)  // moved down
					d = distArg - distance;
			}
			// Slices 3 & 4 -> up/right vs down/left
			else if (sliceNumber == 3 || sliceNumber == 4) {
				if (point.x > xArg) // moved right
					d = distArg + distance;
				else if (point.x < xArg) // moved left
					d = distArg - distance;
				else if (point.y < yArg) // moved up
					d = distArg + distance;
				else if (point.y > yArg) // moved down
					d = distArg - distance;
			}
			// Slices 5 & 6 -> down/right vs up/left
			else if (sliceNumber == 5 || sliceNumber == 6) {
				if (point.x > xArg) // moved right
					d = distArg + distance;
				else if (point.x < xArg) // moved left
					d = distArg - distance;
				else if (point.y < yArg) // moved up
					d = distArg - distance;
				else if (point.y > yArg) // moved down
					d = distArg + distance;
			}
			// Slices 7 & 8 -> down/left vs up/right
			else if (sliceNumber == 7 || sliceNumber == 8) {
				if (point.x > xArg) // moved right
					d = distArg - distance;
				else if (point.x < xArg) // moved left
					d = distArg + distance;
				else if (point.y < yArg) // moved up
					d = distArg - distance;
				else if (point.y > yArg) // moved down
					d = distArg + distance;
			}
			
			xArg = point.x; yArg = point.y;
			[self setTriangle:sliceNumber dist:d];
		}
	}
	
	[self drawStuff];
//	[self setNeedsDisplay];
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	if (inSlice == YES && sliceNumber != -1) {
		IAmBeerAppAppDelegate *del = (IAmBeerAppAppDelegate *)[[UIApplication sharedApplication] delegate];
		if (sliceNumber == 1)
			del.s1amt = [NSString stringWithFormat:@"%f", s1val];
		else if (sliceNumber == 2)
			del.s2amt = [NSString stringWithFormat:@"%f", s2val];
		else if (sliceNumber == 3)
			del.s3amt = [NSString stringWithFormat:@"%f", s3val];
		else if (sliceNumber == 4)
			del.s4amt = [NSString stringWithFormat:@"%f", s4val];
		else if (sliceNumber == 5)
			del.s5amt = [NSString stringWithFormat:@"%f", s5val];
		else if (sliceNumber == 6)
			del.s6amt = [NSString stringWithFormat:@"%f", s6val];
		else if (sliceNumber == 7)
			del.s7amt = [NSString stringWithFormat:@"%f", s7val];
		else if (sliceNumber == 8)
			del.s8amt = [NSString stringWithFormat:@"%f", s8val];
	}
	s1adj.hidden = s2adj.hidden = s3adj.hidden = s4adj.hidden = YES;
	s5adj.hidden = s6adj.hidden = s7adj.hidden = s8adj.hidden = YES;
	sliceNumber = -1;
	inSlice = NO;
}

- (void)dealloc {
    [super dealloc];
	[w release];
	[s1adj release]; [s2adj release]; [s3adj release]; [s4adj release];
	[s5adj release]; [s6adj release]; [s7adj release]; [s8adj release];
}


@end
