//
//  NewReviewTabViewController.m
//  IAmBeerApp
//
//  Created by Class Account on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "IAmBeerAppAppDelegate.h"
#import "NewReviewTabViewController.h"
#import "GeneralTabViewController.h"
#import "DetailsTabViewController.h"
#import "TagsViewController.h"
#import "FlipsideViewController.h"
#import "MainViewController.h"
#import "BeerTasting.h"

@implementation NewReviewTabViewController

@synthesize newTasting;
@synthesize tabBar;
@synthesize generalTabBarItem, detailsTabBarItem, tasteWheelTabBarItem, tagsTabBarItem, resultsTabBarItem;
@synthesize viewControllers;
@synthesize currentViewController, subview;


 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
		
		//Initialize the different tabBarItem Controllers
		GeneralTabViewController *generalTabViewController = [[GeneralTabViewController alloc] initWithNibName:@"GeneralTabViewController" bundle:nil];
		DetailsTabViewController *detailsTabViewController = [[DetailsTabViewController alloc] initWithNibName:@"DetailsTabViewController" bundle:nil];
		MainViewController *mainViewController = [[MainViewController alloc] initWithNibName:@"MainView" bundle:nil];
		TagsViewController *tagsViewController = [[TagsViewController alloc] initWithNibName:@"TagsView" bundle:nil];
		//FlipsideViewController *flipsideViewController = [[FlipsideViewController alloc] initWithNibName:@"FlipsideView" bundle:nil];
		
		//Add the tabBarItem controllers into the array
		NSArray *arrayOfControllers = [[NSArray alloc] initWithObjects:generalTabViewController, detailsTabViewController, mainViewController, tagsViewController, nil];
		self.viewControllers = arrayOfControllers;
		
		//set current view
		[self.view addSubview:generalTabViewController.view];

		self.currentViewController = generalTabViewController;
		
		//Release temp variables
		[arrayOfControllers release];
		[generalTabViewController release];
		[detailsTabViewController release];
		[mainViewController release];
		//[flipsideViewController release];
    }
    return self;
}



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	tabBar.selectedItem = generalTabBarItem;
	[self setTitle:@"General Info"];
	[super viewDidLoad];
	
	//Initialize a new beer tasting object
	BeerTasting *aTasting = [[BeerTasting alloc] init];
	self.newTasting = aTasting;
	[aTasting release];
	
	NSLog(@"%d", aTasting.idNumber);
	
	IAmBeerAppAppDelegate *del = (IAmBeerAppAppDelegate *)[[UIApplication sharedApplication] delegate];
	del.s1amt = [NSString stringWithFormat:@"%f", 0.0];
	del.s2amt = [NSString stringWithFormat:@"%f", 0.0];
	del.s3amt = [NSString stringWithFormat:@"%f", 0.0];
	del.s4amt = [NSString stringWithFormat:@"%f", 0.0];
	del.s5amt = [NSString stringWithFormat:@"%f", 0.0];
	del.s6amt = [NSString stringWithFormat:@"%f", 0.0];
	del.s7amt = [NSString stringWithFormat:@"%f", 0.0];
	del.s8amt = [NSString stringWithFormat:@"%f", 0.0]; 
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)tabBar:(UITabBar *)tabBar didSelectItem:(UITabBarItem *)item {
	if (item == generalTabBarItem) {
		UIViewController *generalTabViewController = [viewControllers objectAtIndex:0];
		[self.currentViewController.view removeFromSuperview];
		[subview addSubview:generalTabViewController.view];
		self.currentViewController = generalTabViewController;
		[self setTitle:@"General Info"];
	}
	else if (item == detailsTabBarItem) {
		newTasting.name = [[[viewControllers objectAtIndex:0] beerName] text];
		IAmBeerAppAppDelegate *appDelegate = (IAmBeerAppAppDelegate *)[[UIApplication sharedApplication] delegate];
		[[appDelegate listOfBeers] addObject:newTasting];
		
		UIViewController *detailsTabViewController = [viewControllers objectAtIndex:1];
		[self.currentViewController.view removeFromSuperview];
		[subview addSubview:detailsTabViewController.view];
		self.currentViewController = detailsTabViewController;
		[self setTitle:@"Details of Beer"];
	}
	else if (item == tasteWheelTabBarItem) {
		UIViewController *mainViewController = [viewControllers objectAtIndex:2];
		[self.currentViewController.view removeFromSuperview];
		[subview addSubview:mainViewController.view];
		self.currentViewController = mainViewController;
		[self setTitle:@"Taste Wheel"];
	}
	else if (item == tagsTabBarItem) {
		UIViewController *tagsViewController = [viewControllers objectAtIndex:3];
		[self.currentViewController.view removeFromSuperview];
		[subview addSubview:tagsViewController.view];
		self.currentViewController = tagsViewController;
		[self setTitle:@"Beer Tags"];		
	}
	else if (item == resultsTabBarItem) {
		//UIViewController *flipsideViewController = [viewControllers objectAtIndex:3];
		UIViewController *flipsideViewController = [[FlipsideViewController alloc] initWithNibName:@"FlipsideView" bundle:nil];
		[self.currentViewController.view removeFromSuperview];
		[subview addSubview:flipsideViewController.view];
		self.currentViewController = flipsideViewController;
		[self setTitle:@"Results"];
		[flipsideViewController release];
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[newTasting release];
	[tabBar release];
	[generalTabBarItem release];
	[detailsTabBarItem release];
	[tasteWheelTabBarItem release];
	[resultsTabBarItem release];
	[tagsTabBarItem release];
	[viewControllers release];
	[currentViewController release];
	[subview release];
	
    [super dealloc];
}


@end
