//
//  RankingViewController.m
//  IAmBeerApp
//
//  Created by Class Account on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "IAmBeerAppAppDelegate.h"
#import "RankingViewController.h"
#import "CategoryItems.h"
#import "ReorderViewController.h"

@implementation RankingViewController

@synthesize reorderViewController;
@synthesize segmentedControl, displayTable, currentTableView, tagTableView, breweryTableView, locationTableView;
@synthesize listOfTags, listOfBrewery, listOfLocations;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	[segmentedControl addTarget:self action:@selector(sortBy:) forControlEvents:UIControlEventValueChanged];
	
	ReorderViewController *aReorderViewController = [[ReorderViewController alloc] initWithNibName:@"ReorderViewController" bundle:[NSBundle mainBundle]];
	self.reorderViewController = aReorderViewController;
	[aReorderViewController release];
	
	IAmBeerAppAppDelegate *appDelegate = (IAmBeerAppAppDelegate *)[[UIApplication sharedApplication] delegate];
	/*
	listOfTags = [[NSMutableArray alloc] initWithObjects:
				  [[[CategoryItems alloc] initWithName:@"sweet" values:nil] autorelease],
				  [[[CategoryItems alloc] initWithName:@"hoppy" values:nil] autorelease], nil];
	*/
	listOfTags = [appDelegate listOfTags];
	listOfBrewery = [appDelegate listOfBrewery];
	listOfLocations = [appDelegate listOfLocations];
	
	[displayTable addSubview:tagTableView];
	currentTableView = tagTableView;
	
	[self setTitle:@"Beer Ranking"];

}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)sortBy:(id)sender {
	int index = segmentedControl.selectedSegmentIndex;
	[currentTableView removeFromSuperview];
	
	if (index == 0) {
		[displayTable addSubview:tagTableView];
	}
	else if (index == 1) {
		[displayTable addSubview:breweryTableView];
	}
	else if (index == 2) {
		[displayTable addSubview:locationTableView];
	}
	
	NSLog(@"index %d", segmentedControl.selectedSegmentIndex);
}

#pragma mark TableView methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	if (tableView == tagTableView) {
		return [listOfTags count];
	} else if (tableView == breweryTableView) {
		return [listOfBrewery count];
	} else if (tableView == locationTableView) {
		return [listOfLocations count];
	} else return 0;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Set up the cell...
	[cell.textLabel setTextAlignment:UITextAlignmentCenter];
	if (tableView == tagTableView) {
		[cell.textLabel	setText:[[listOfTags objectAtIndex:indexPath.row] name]];
	} else if (tableView == breweryTableView) {
		[cell.textLabel	setText:[[listOfBrewery objectAtIndex:indexPath.row] name]];
	} else if (tableView == locationTableView) {
		[cell.textLabel	setText:[[listOfLocations objectAtIndex:indexPath.row] name]];
	}

    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	CategoryItems *item = nil;
	NSString *alertMessage = nil;
	if (tableView == tagTableView) {
		item = [listOfTags objectAtIndex:indexPath.row];
		alertMessage = @"This tag has not been added to any beer reviews.";
	} else if (tableView == breweryTableView) {
		item = [listOfBrewery objectAtIndex:indexPath.row];	
		alertMessage = @"No beers from this brewery have been reviewed.";
	} else if (tableView == locationTableView) {
		item = [listOfLocations objectAtIndex:indexPath.row];
		alertMessage = @"No beers were reviewed from this location.";
	}
	
	if ([item listOfBeers] == nil) {
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"No Beers Found" 
														message:alertMessage delegate:self cancelButtonTitle:@"Close" otherButtonTitles:nil];
		
		[alert show];
		[alert release];
	} else {
		reorderViewController.tableToSort = tableView;
		reorderViewController.sortingData = [item listOfBeers];
		[[self navigationController] pushViewController:reorderViewController animated:YES];
	}
	
	[tableView deselectRowAtIndexPath:indexPath animated:YES];
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[segmentedControl release];
	[reorderViewController release];
	[displayTable release];
	[currentTableView release];
	[tagTableView release];
	[breweryTableView release];
	[locationTableView release];
	[listOfTags release];
	[listOfBrewery release];
	[listOfLocations release];
    [super dealloc];
}


@end
