//
//  ReorderViewController.m
//  IAmBeerApp
//
//  Created by Class Account on 4/4/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ReorderViewController.h"
#import "IAmBeerAppAppDelegate.h"
#import "CategoryItems.h"
#import "BeerTasting.h"

@implementation ReorderViewController
@synthesize tableToSort, sortingData, listOfBeers;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	[self setTitle:@"Drag to Reorder"];
	
	IAmBeerAppAppDelegate *appDelegate = (IAmBeerAppAppDelegate *)[[UIApplication sharedApplication] delegate];
	listOfBeers = [appDelegate listOfBeers];
	NSLog(@"count %d",[listOfBeers count]);
	tableToSort.editing = YES;
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

#pragma mark TableView methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)TableView {
	return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [sortingData count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Set up the cell...
	[cell.textLabel setTextAlignment:UITextAlignmentCenter];
	NSInteger beerID = [[sortingData objectAtIndex:indexPath.row] intValue];
	NSLog(@"index %d ; beerID %d", indexPath.row, beerID);
	[cell.textLabel	setText:[[listOfBeers objectAtIndex:beerID] name]];
	
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	[tableView deselectRowAtIndexPath:indexPath animated:YES];
}

- (UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return UITableViewCellEditingStyleNone;
}

- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
	return YES;
}

- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
	NSNumber *item = [[sortingData objectAtIndex:fromIndexPath.row] retain];
	[sortingData removeObject:item];
	[sortingData insertObject:item atIndex:toIndexPath.row];
	[item release];
}

#pragma mark Memory Management

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[tableToSort release];
	[sortingData release];
	[listOfBeers release];
    [super dealloc];
}


@end
